View Issue Details

IDProjectCategoryView StatusLast Update
0020726FPCCompilerpublic2013-03-05 23:26
ReporterFelipe Monteiro de CarvalhoAssigned ToThomas Schatzl 
PrioritynormalSeverityfeatureReproducibilityhave not tried
Status resolvedResolutionfixed 
Product VersionProduct Build 
Target Version2.7.1Fixed in Version3.0.0 
Summary0020726: Basic support for Android
DescriptionHello,

As discussed in the mailling list and in private. My prefered method is having a separate target because this allows a more smooth development of structural libraries which need to differentiate between arm-linux and Android.

The latest Android breakage was introduced here:

http://svn.freepascal.org/cgi-bin/viewvc.cgi?view=rev&revision=19036

Previously there was also this one:

http://svn.freepascal.org/cgi-bin/viewvc.cgi?view=rev&revision=16981

I'd also recommend the following:

* Don't change into a libc based RTL, keep using syscalls, like Google recommended. Besides being recommended by Google this is also less work.
* argc=argv=nil is good enough for Android. We don't necessarely need those in Android, although if you find a reliable way to get them it's also fine for me.
TagsNo tags attached.
Fixed in Revisionr23604
FPCOldBugId0
FPCTarget
Attached Files

Relationships

has duplicate 0022818 resolvedFelipe Monteiro de Carvalho Introduce ARMv7 with floating point as a separate CPU architecture on Android 
related to 0018833 resolvedThomas Schatzl envp is not set correctly under armv5-android 
related to 0021208 resolvedFelipe Monteiro de Carvalho Example androidlcl does not run when you add a DataSource 
related to 0021341 resolvedFelipe Monteiro de Carvalho Need Patch for Android 
related to 0021853 resolvedYuriy Sydorov IFDEF-conditional Android patch for the arm//linux RTL 

Activities

Sven Barth

2012-02-06 10:44

manager   ~0056569

Out of curiosity: Where did Google recommend to use syscalls?

Regards,
Sven

Felipe Monteiro de Carvalho

2012-02-21 15:12

developer   ~0056974

Google Groups
Group: Android-NDK
Topic: Are Linux syscalls safe in Android?
First message by Felipe Monteiro de Carvalho
Nov 16 2011, 5:11 pm

http://groups.google.com/group/android-ndk/browse_thread/thread/3247d4a02d3e530c/2f879289a1c2567f?lnk=gst&q=Felipe#2f879289a1c2567f

Sven Barth

2012-02-22 09:21

manager   ~0056994

Nice to know that. Thank you. :)

Regards,
Sven

Thomas Schatzl

2012-04-26 15:23

developer   ~0059020

Have a look at the new http://svn.freepascal.org/svn/fpc/branches/targetandroid/ branch which implements compiler level arm/android support.

Seva Alekseyev

2012-09-11 17:09

reporter   ~0062291

Last edited: 2012-09-11 17:09

In case anyone is reading this: what's the status of the "targetandroid" branch, please? Is it ready for prime time yet?

The only available doc on targeting Android with FPC is http://wiki.lazarus.freepascal.org/Custom_Drawn_Interface/Android

Sven Barth

2012-09-13 14:32

manager   ~0062327

Unlike the unofficial 2.5.1 branch this is the officially supported version that should somewhen in the future be merged to trunk. If you want to test it you need to specify "arm" as CPU and "android" as OS when building the compiler and/or programs.

Regards,
Sven

Takeda Matsuki

2012-09-25 11:11

reporter   ~0062610

I cannot build official ' target android branch ' (2.7.1 based). Sad. :(
I already test with any possible ways but always failed.

Sven Barth

2012-09-25 11:52

manager   ~0062613

You should ask on the mailing list (e.g. fpc-devel) if you have troubles.

Regards,
Sven

Yuriy Sydorov

2013-02-13 20:13

manager   ~0065674

Android support now in trunk.

Issue History

Date Modified Username Field Change
2011-11-21 20:05 Felipe Monteiro de Carvalho New Issue
2011-11-21 20:05 Felipe Monteiro de Carvalho Status new => assigned
2011-11-21 20:05 Felipe Monteiro de Carvalho Assigned To => Thomas Schatzl
2011-11-21 20:05 Felipe Monteiro de Carvalho FPCOldBugId => 0
2011-11-21 20:05 Felipe Monteiro de Carvalho Relationship added related to 0018833
2012-02-04 08:19 Felipe Monteiro de Carvalho Relationship added related to 0021208
2012-02-06 10:44 Sven Barth Note Added: 0056569
2012-02-21 15:10 Felipe Monteiro de Carvalho Relationship added related to 0021341
2012-02-21 15:12 Felipe Monteiro de Carvalho Note Added: 0056974
2012-02-22 09:21 Sven Barth Note Added: 0056994
2012-04-24 22:22 Marco van de Voort Relationship added related to 0021853
2012-04-26 15:23 Thomas Schatzl Note Added: 0059020
2012-09-07 12:56 Jonas Maebe Relationship added has duplicate 0022818
2012-09-11 17:09 Seva Alekseyev Note Added: 0062291
2012-09-11 17:09 Seva Alekseyev Note Edited: 0062291
2012-09-13 14:32 Sven Barth Note Added: 0062327
2012-09-25 11:11 Takeda Matsuki Note Added: 0062610
2012-09-25 11:52 Sven Barth Note Added: 0062613
2013-02-13 20:13 Yuriy Sydorov Fixed in Revision => r23604
2013-02-13 20:13 Yuriy Sydorov Note Added: 0065674
2013-02-13 20:13 Yuriy Sydorov Status assigned => resolved
2013-02-13 20:13 Yuriy Sydorov Fixed in Version => 2.7.1
2013-02-13 20:13 Yuriy Sydorov Resolution open => fixed
2013-02-13 20:13 Yuriy Sydorov Target Version => 2.7.1